﻿using System;
using System.Collections.Generic;
using System.IO;
using System.Linq;
using System.Text.RegularExpressions;
using System.Web;
using System.Web.Optimization;

/// <summary>
/// CSS and JS Bundles for all pages : BundleConfig
/// </summary>
/// <Author>  Prashik  </Author>

public class BundleConfig
{
    public static void RegisterBundles(BundleCollection bundles)
    {
        #region SmartViews + Listviews + InMemoryDB => iview.aspx
        StyleBundle smartviewsCSS = new StyleBundle("~/Css/smartviews");
        smartviewsCSS.Include(
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/Responsive/css/responsive.bootstrap.min.css",
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/css/les.min.css",
            // "~/ThirdParty/DataTables-1.10.13/extensions/Scroller/css/scroller.dataTables.css",
            "~/ThirdParty/bgrins-spectrum/spectrum.css",
            "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.css",
            "~/Css/globalStyles.css",
            "~/Css/iviewNewUi.css",
            "~/Css/animate.min.css",
            "~/Css/jquery-ui-timepicker-addon.min.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/Js/jquery.timeentry.package/jquery.timeentry.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css"
        );
        smartviewsCSS.EnableFileExtensionReplacements = true;
        smartviewsCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        smartviewsCSS.Orderer = new BundleSorter();
        bundles.Add(smartviewsCSS);

        var smartviewsJS = new ScriptBundle("~/Js/smartviews")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/Js/noConflict.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/Thirdparty/newMaterialUI/plugins/node-waves/waves.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.js",
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/dataTables.buttons.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.flash.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.html5.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/buttons.print.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/jszip.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/pdfmake.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Buttons/js/vfs_fonts.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/FixedColumns/js/dataTables.fixedColumns.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Scroller/js/dataTables.scroller.js",
             "~/Js/alerts.js",//min
             "~/newPopups/Remodal/remodal.js",//min
             "~/newPopups/axpertPopup.js",//min
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/handlebars.min.js",
             "~/Js/thirdparty/jquery-ui/1.12.1/jquery-ui.min.js",
             "~/ThirdParty/Highcharts/highcharts.js",
             "~/ThirdParty/Highcharts/highcharts-3d.js",
             "~/ThirdParty/Highcharts/highcharts-more.js",
             "~/ThirdParty/Highcharts/highcharts-exporting.js",
             "~/Js/common.js",//min
             "~/Js/iview.js",//min
             "~/Js/jsclient.js",//min
             "~/Js/process.js",//min
             "~/Js/helper.js",//min
             "~/Js/util.min.js",
             "~/Js/JDate.min.js",
             "~/Js/jquery-ui-timepicker-addon.min.js",
             "~/Js/jquery.timeentry.package/jquery.timeentry.min.js",
             "~/ThirdParty/bootstrap-tokenfield/dist/bootstrap-tokenfield.min.js",
             "~/Js/jquery.browser.min.js",
             "~/Js/printjs.js",//min
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/moment.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/jquery.visible.min.js",
             "~/ThirdParty/DataTables-1.10.13/extensions/Extras/datetime-moment.js",
             "~/Js/iviewjs.js",//min
             "~/Js/smartViews.js",//min
             "~/ThirdParty/bgrins-spectrum/spectrum.js"
            );
        smartviewsJS.EnableFileExtensionReplacements = true;
        smartviewsJS.Orderer = new BundleSorter();
        bundles.Add(smartviewsJS);
        #endregion

        #region Form => tstruct.aspx
        StyleBundle formCSS = new StyleBundle("~/Css/form");
        formCSS.Include(
            "~/Css/thirdparty/bootstrap/3.3.6/bootstrap.min.css",
            "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.structure.min.css",
            "~/Css/thirdparty/jquery-ui/1.12.1/jquery-ui.theme.min.css",
            "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.css",
            "~/ThirdParty/DataTables-1.10.13/media/css/jquery.dataTables.min.css",
            "~/Css/Icons/icon.css",
            "~/Css/thirdparty/font-awesome/4.6.3/css/font-awesome.min.css",
            "~/ThirdParty/codemirror/codemirror.css",
            "~/Css/jquery-ui-timepicker-addon.min.css",
            "~/Js/jquery.timeentry.package/jquery.timeentry.css",
            "~/Css/globalStyles.css",
            "~/Css/wizardComp.css",
            "~/css/ExportNew.css",
            "~/Css/import.css",
            "~/Css/responsibilties.css",
            "~/Css/propSheet.css",
            "~/Css/msgBoxLight.css",
            "~/Css/tstructNewUi.css",
            "~/Css/animate.min.css",
            "~/ThirdParty/bootstrap-tokenfield/dist/css/bootstrap-tokenfield.min.css",
            "~/newPopups/Remodal/remodal-default-theme.min.css",
            "~/newPopups/Remodal/remodal.min.css",
            "~/Css/axpertPopup.css"
        );
        formCSS.EnableFileExtensionReplacements = true;
        formCSS.Transforms.Insert(0, new CssRewriteUrlTransformWrapper());
        formCSS.Orderer = new BundleSorter();
        bundles.Add(formCSS);
        //BundleTable.EnableOptimizations = true;



        var formBasic = new ScriptBundle("~/Js/formBasic")
            .Include(
             "~/Js/thirdparty/jquery/3.1.1/jquery.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/jquery.dataTables.min.js",
             "~/ThirdParty/DataTables-1.10.13/media/js/dataTables.bootstrap.min.js",
             "~/Js/jquery.browser.min.js",
             "~/Js/printjs.js",//min
             "~/ThirdParty/jquery-confirm-master/jquery-confirm.min.js",
             "~/Js/noConflict.min.js",
             "~/Js/propSheet.js",
             "~/Js/jquery.timeentry.package/jquery.timeentry.min.js",
             "~/Js/alerts.js",//min
             "~/Js/jQueryUi/jquery.tablesorter.min.js",
             "~/ThirdParty/bootstrap-tokenfield/dist/bootstrap-tokenfield.min.js",
             "~/Js/common.js",//min
             "~/Js/ckeditor/ckeditor.js",
             "~/Js/ckRtf.js",
             //"~/Js/process.min.js",
             "~/Js/JDate.min.js",
             "~/Js/thirdparty/bootstrap/3.3.6/bootstrap.min.js",
             "~/Js/thirdparty/jquery-ui/jquery-ui-autoCom/jquery-ui-autoCom.min.js",
             "~/Js/jquery-ui-timepicker-addon.min.js",
             "~/ThirdParty/lodash.min.js",
             "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.js",
             "~/ThirdParty/gridstack.js-0.3.0/dist/gridstack.jQueryUI.js",
             "~/Js/jquery.msgBox.min.js",
             "~/Js/jQueryUi/jquery.scrollabletab.min.js",
             "~/Js/tstructvars.js",//min
             "~/Js/md5.min.js",
             "~/Js/adjustwindow.js",
             "~/Js/wizardComp.js",//min
             //"~/Js/tstruct.min.js",
             //"~/Js/helper.min.js",
             //"~/Js/jsclient.min.js",
             "~/Js/util.min.js",
             //"~/Js/main-tstruct.min.js",
             "~/Js/tstruct-pdf.min.js",
             //"~/Js/newGridJS.min.js",
             "~/newPopups/Remodal/remodal.min.js",
             "~/newPopups/axpertPopup.js",//min
             "~/Js/handlebars.min.js",
             //"~/Js/autoComplete.min.js",
             "~/Js/thirdparty/velocity.min.js",
             "~/Js/thirdparty/velocity.ui.min.js",
             "~/Js/dimmingdiv.min.js",
             "~/Js/expressions_config.min.js",
             "~/Js/createTheEditor.js",//min
             "~/Js/codemirror/codemirror.js",
             "~/Js/multiselect.min.js",
             "~/Js/codemirror/mode/sql.js",
             "~/Js/codemirror/addon/hint/sql-hint.js",
             "~/Js/sqlBuilder.js"//min
            );
        formBasic.EnableFileExtensionReplacements = true;
        formBasic.Orderer = new BundleSorter();
        bundles.Add(formBasic);

        var formInit = new ScriptBundle("~/Js/formInit")
            .Include(
             "~/Js/process.js",//min
             "~/Js/tstruct.js",//min
             "~/Js/helper.js",//min
             "~/Js/jsclient.js",//min
             "~/Js/main-tstruct.js",//min
             "~/Js/newGridJS.js",//min
             "~/Js/autoComplete.js",//min
             "~/Js/multigroupselect.js"//min
            );
        formInit.EnableFileExtensionReplacements = true;
        formInit.Orderer = new BundleSorter();
        bundles.Add(formInit);
        #endregion
    }
}

//public class CssRewriteUrlTransformWrapper : IItemTransform
//{
//    public string Process(string includedVirtualPath, string input)
//    {
//        return new CssRewriteUrlTransform().Process("~" + VirtualPathUtility.ToAbsolute(includedVirtualPath), input);
//    }
//}

public class CssRewriteUrlTransformWrapper : IBundleTransform
{
    private static Regex pattern = new Regex(@"url\s*\(\s*([""']?)([^:)]+)\1\s*\)", RegexOptions.IgnoreCase);

    public void Process(BundleContext context, BundleResponse response)
    {
        response.Content = string.Empty;
        foreach (BundleFile file in response.Files)
        {
            using (var reader = new StreamReader(file.VirtualFile.Open()))
            {
                var contents = reader.ReadToEnd();
                var matches = pattern.Matches(contents);
                if (matches.Count > 0)
                {
                    var directoryPath = VirtualPathUtility.GetDirectory(file.VirtualFile.VirtualPath);
                    foreach (Match match in matches)
                    {
                        var fileRelativePath = match.Groups[2].Value;
                        var fileVirtualPath = VirtualPathUtility.Combine(directoryPath, fileRelativePath);
                        var quote = match.Groups[1].Value;
                        var replace = String.Format("url({0}{1}{0})", quote, VirtualPathUtility.ToAbsolute(fileVirtualPath));
                        contents = contents.Replace(match.Groups[0].Value, replace);
                    }
                }
                response.Content = String.Format("{0}\r\n{1}", response.Content, contents);
            }
        }
    }
}
